HDU 1024 Max Sum Plus Plus (DP,水题)

Max Sum Plus Plus

题目链接

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 30905 Accepted Submission(s): 10891

Problem Description
Now I think you have got an AC in Ignatius.L’s “Max Sum” problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S1, S2, S3, S4 … Sx, … Sn (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ Sx ≤ 32767). We define a function sum(i, j) = Si + … + Sj (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i1, j1) + sum(i2, j2) + sum(i3, j3) + … + sum(im, jm) maximal (ix ≤ iy ≤ jx or ix ≤ jy ≤ jx is not allowed).

But I`m lazy, I don’t want to write a special-judge module, so you don’t have to output m pairs of i and j, just output the maximal summation of sum(ix, jx)(1 ≤ x ≤ m) instead. ^_^

Input
Each test case will begin with two integers m and n, followed by n integers S1, S2, S3 … Sn.
Process to the end of file.

Output
Output the maximal summation described above in one line.

Sample Input
1 3 1 2 3
2 6 -1 4 -2 3 -2 3

Sample Output
6
8

Hint

Huge input, scanf and dynamic programming is recommended.

Author
JGShining(极光炫影)

题意

给n个数,将其分为m部分,各部分之间不能有交叉重叠,求最大和

思路

dp[i][j]表示前j个数分为i部分的最大和,则
dp[i][j] = max(dp[i][j-1] + a[j], dp[i-1][k] + a[j]) i-1<=k<=j-1
前者是将第j个数加入到第i部分,后者是将第j个数做为第i部分的第一个数。

两个关键点

因为题目n值范围过大,显然二维数组不行。
而d[i][x]只与d[i-1][x]有关,所以可以将其降低至一维。
即dp[j]表示前j个数所分段后的和。
因为dp[i-1][k]的取值需要一重循环,极有可能导致超时,所以使用数组max存储当前层的最大值,以供下一层求值使用。
dp[j] = max(dp[j-1] + a[j], max[j-1] + a[j])

#include<algorithm>
#include<iostream>
#include<cstdio>
#include<cstring>
#define me(a) memset(a,0,sizeof(a))
using namespace std;
int a[1000010];
int b[1000010];
int dp[100010];
int main()
{
    int n,m;
    while(scanf("%d %d",&n,&m)!=EOF)
    {
        for(int i=1;i<=m;i++)
            scanf("%d",&a[i]);
        me(dp),me(b);
        int maxx;
        for(int i=1;i<=n;i++)
        {
            maxx=-0x3f3f3f3f;
            for(int j=i;j<=m;j++)
            {
                dp[j]=max(dp[j-1]+a[j],b[j-1]+a[j]);
                b[j-1]=maxx;
                maxx=max(maxx,dp[j]);
            }
        }

        printf("%d\n",maxx);
    }
    return 0;
}
posted @ 2017-08-12 21:25  南风古  阅读(116)  评论(0编辑  收藏  举报